var system = require("../../../system");
var settings = require("../../../../config/settings");
const AppServiceBase = require("../../app.base");
const logCtl = system.getObject("service.common.oplogSve");
const aliyunClient = system.getObject("util.aliyunClient");

class UtilsFqAliyunSve extends AppServiceBase {
  constructor() {
    super();
  }
  async pushOldNeedBusiness(actionBody) {//推送旧的需求商机
    return system.getResultSuccess();
  }
  async pushOrderBusiness(actionBody) {//推送订单商机
    var orderInfo = actionBody.order_info;
    if (!orderInfo) {
      return "";
    }
    if (orderInfo.orderStatus < 2) {
      return "";
    }
    var orderContact = actionBody.order_contact;
    var productInfo = actionBody.product_info;
    if (!actionBody.interface_params) {
      return "";
    }
    var interface_params_info = JSON.parse(actionBody.interface_params);
    if (!interface_params_info || !interface_params_info.opUrl || !interface_params_info.key || !interface_params_info.secret) {
      return "";
    }
    var params = {
      idempotentId: orderInfo.orderNo,// 是 业务 ID
      idempotentSource: productInfo.service_business_code,// 是 业务来源（ic_jdyun、ic_ali）
      idempotentSourceName: productInfo.service_business_code,// 是 京东云应用、阿里云应用
      city: "",// 否 所属城市
      phone: orderContact.mobile,// 是 手机号
      userId: orderInfo.channelUserId,// 否 用户 ID
      companyName: "",// 否 公司名称
      orderPrice: orderInfo.totalSum,// 是 订单金额
      productId: productInfo.price_item.service_code,// 是 产品 ID
      productQuantity: orderInfo.quantity,// 是 产品数量
    };
    var result = this.opAliyunClientPost("pushOrderBusiness", interface_params_info.opUrl, interface_params_info.key, interface_params_info.secret, params);
  }

  async opAliyunClientPost(methodName, url, key, secret, params) {
    try {
      var rc = system.getObject("util.aliyunClient");
      var rtn = = await rc.post(url, key, secret, params);
      this.logCtl.info({
        appid: pobj.appInfo.uapp_id,
        appkey: pobj.appInfo.uappKey,
        requestId: req.requestId || "",
        op: "center-channel/app/base/service/impl/utilsSve/utilsFqAliyunSve.js/" + methodName,
        content: "请求地址：" + url + "，参数：" + JSON.stringify(params) + "，返回结果：" + JSON.stringify(rtn),
        clientIp: pobj.clientIp,
        optitle: "推送订单商机到FQ信息--again",
      });
      if (rtn.code != 200 && rtn.success != true) {
        return system.getResult(null, "推送失败，失败原因：" + rtn.errorMsg + "，selfrequestId=" + req.requestId + "，requestId=" + rtn.requestId);
      }
      return system.getResultSuccess(null, "推送成功");
    } catch (e) {
      //日志记录
      this.logCtl.error({
        appid: pobj.appInfo.uapp_id,
        appkey: pobj.appInfo.uappKey,
        requestId: req.requestId || "",
        op: "center-channel/app/base/service/impl/utilsSve/utilsFqAliyunSve.js/" + methodName,
        content: "error：" + e.stack,
        clientIp: pobj.clientIp,
        optitle: "推送操作出错->opAliyunClientPost",
      });
    }
  }
}
module.exports = UtilsFqAliyunSve;
