const system = require("../../../system");
var settings = require("../../../../config/settings");
const querystring = require('querystring');
const AppServiceBase = require("../../app.base");
class UtilsOpOrderService extends AppServiceBase {
  constructor() {
    super();
    this.centerOrderUrl = settings.centerOrderUrl();
    this.utilsPushSve = system.getObject("service.utilsSve.utilsPushSve");
  }
  async updateContacts(pobj, actionBody) {
    if (!actionBody.orderNo) {
      return system.getResult(null, "actionBody.orderNo can not be empty，100310");
    }
    var reqUrl = this.centerOrderUrl + "opaction/opOrder/springBoard";
    var result = await this.restPostUrl(pobj, reqUrl);
    this.opUpdatePushInfo(result, pobj, actionBody, "pushUpdateContacts");
    result.data = null;
    return result;
  }
  async updateTmOrder(pobj, actionBody) {
    if (!actionBody.orderNo) {
      return system.getResult(null, "actionBody.orderNo can not be empty，100320");
    }
    var reqUrl = this.centerOrderUrl + "opaction/opOrder/springBoard";
    var result = await this.restPostUrl(pobj, reqUrl);
    this.opUpdatePushInfo(result, pobj, "pushUpdateOrder");
    result.data = null;
    return result;
  }
  async opUpdatePushInfo(result, pobj, opType) {
    if (result.status == 0 && result.data.orderStatus < 4) {
      result.data.appInfo = {
        uapp_id: pobj.appInfo.uapp_id,
        uapp_key: pobj.appInfo.uapp_key,
        app_code: pobj.appInfo.app_code,
        app_name: pobj.appInfo.app_name
      };
      result.data.userInfo = {
        channel_userid: pobj.userInfo.channel_userid,
        channel_username: pobj.userInfo.channel_username,
        channel_nickname: pobj.userInfo.channel_nickname
      };
      delete result.data["orderStatus"];
      this.utilsPushSve.pushInfo(result.data, opType, 1);
    }
  }
}
module.exports = UtilsOpOrderService;
