const system = require("../../../system");
var settings = require("../../../../config/settings");
const querystring = require('querystring');
const AppServiceBase = require("../../app.base");
class UtilsPushService extends AppServiceBase {
  constructor() {
    super();
    this.pushlogSve = system.getObject("service.common.pushlogSve");
  };
  async pushInfo(actionBody, opType, isDelProductInfo) {
    var interface_list = actionBody.product_info.interface_info;
    if (!interface_list) {
      return "";
    }
    var interface_list_temp = interface_list.filter(f => f.op_type == opType)
    if (!interface_list_temp || interface_list_temp.length == 0) {
      return "";
    }
    for (let index = 0; index < interface_list_temp.length; index++) {
      const element = interface_list_temp[index];
      var refOpResult = this.reflexAction(element, actionBody, isDelProductInfo);
    }
  }
  async reflexAction(interface_info, actionBody, isDelProductInfo) {
    var refResult = null;
    try {
      if (interface_info.interface_type == "bd") {
        if (!interface_info.method_name) {
          return system.getResult(null, "产品接口参数信息有误，100350");
        }//操作的方法名称
        var invokeObj = system.getObject(interface_info.interface_url);
        if (!invokeObj[interface_info.method_name]) {
          return system.getResult(null, "产品接口参数方法信息有误，100360");
        }
        actionBody.interface_params = interface_info.params;
        var params = [actionBody];
        refResult = await invokeObj[interface_info.method_name].apply(invokeObj, params);
      }
      else if (interface_info.interface_type == "yc") {
        if (!interface_info.interface_url) {
          return system.getResult(null, "产品接口interface_url参数不能为空，100370");
        }
        delete actionBody.product_info["price_list"];
        delete actionBody.product_info["interface_info"];
        if (isDelProductInfo && isDelProductInfo == 1) {
          delete actionBody["product_info"];
        }//是否删除产品信息进行推送
        refResult = await this.restPostUrl(actionBody, interface_info.interface_url);
      }
      this.pushlogSve.createDb({
        appid: actionBody.appInfo.uapp_id,
        appkey: actionBody.appInfo.uapp_key,
        op: "推送的接口信息：" + JSON.stringify(interface_info),
        content: JSON.stringify(actionBody),
        resultInfo: refResult ? JSON.stringify(refResult) : "",
        returnType: '1',
        opTitle: "数据推送成功"
      });
      return refResult;
    } catch (e) {
      this.pushlogSve.createDb({
        appid: actionBody.appInfo.uapp_id,
        appkey: actionBody.appInfo.uapp_key,
        op: "推送的接口信息：" + JSON.stringify(interface_info),
        content: JSON.stringify(actionBody),
        resultInfo: JSON.stringify(e.stack),
        returnType: '0',
        opTitle: "数据推送异常"
      });
    }
  }
}
module.exports = UtilsPushService;
